<?php
/**
 * Author: AA-Team
 * Author URI: http://www.aa-team.com
 * Text Domain: aa-envato-demo-bar
 */

// Exit if accessed directly.
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if (class_exists('AA_DBAR_Stats') != true) {
	class AA_DBAR_Stats {
		private $cfg = array();
		protected static $instance = null;

		private $hits_db_name = '';
		private $items_db_name = '';
		private $db = '';

		public static function getInstance()
		{
			if (!isset(static::$instance)) {
				static::$instance = new static;
			}
			return static::$instance;
		}

		protected function __construct()
		{
			global $wpdb;
			$this->db = $wpdb;

			$this->hits_db_name = $this->db->prefix . "demo_bar_hits";
			$this->items_db_name = $this->db->prefix . "demo_bar_items";
		}

		public function get_item_details( $itemID=0 )
		{
			$hits = $this->db->get_results( "SELECT a.*, UNIX_TIMESTAMP( a.data ) as timestamp FROM $this->hits_db_name AS a WHERE 1=1 AND itemID={$itemID} AND a.data > (now() - INTERVAL 24 HOUR)", ARRAY_A );

			$item = $this->db->get_row( "SELECT * FROM $this->items_db_name WHERE 1=1 AND ID={$itemID}", ARRAY_A );

			$one_week_hits = $this->db->get_results( "SELECT  DATE(data) Date, COUNT(DISTINCT ID) totalCount, COUNT(DISTINCT ip) uniqueIP FROM $this->hits_db_name WHERE 1=1 AND itemID={$itemID} GROUP BY DATE(data) ", ARRAY_A );

			return array(
				'hits' => $hits,
				'item' => $item,
				'one_week_hits' => $one_week_hits
			);
		}

		public function get_last_hits( $nb_of_seconds=0 )
		{ 
			return $this->db->get_results( "SELECT a.*, UNIX_TIMESTAMP( a.data ) as timestamp, b.name, b.short_name FROM $this->hits_db_name AS a LEFT JOIN $this->items_db_name AS b ON a.itemID=b.ID WHERE 1=1 AND a.data > (now() - INTERVAL {$nb_of_seconds} SECOND)", ARRAY_A );
		}

		public function save_hits( $request )
		{
			$ip = $this->get_ip_address();
			if( $ip ){
				$ip_info = $this->ip_info( $ip );

				$data = array(
					'itemID' => $request['itemID'],
					'city' => $ip_info['city'],
					'is_mobile' => $request['isMobile'] ? 'Y' : 'N',
					'country' => $ip_info['country'],
					'demo_url' => $request['demo_url'],
					'resolution' => $request['resolution'],
					'country_code' => $ip_info['country_code'],
					'continent' => $ip_info['continent'],
					'continent_code' => $ip_info['continent_code'],
					'state' => $ip_info['state'],
					'referral' => isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : '',
					'ip' => $ip
				);

				$this->db->insert( $this->hits_db_name, $data, array( 
					'%d', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s'
				) );

				return $this->db->insert_id;
			}

			die("Unable to get the ip address!");
		}

		public function get_ip_address() {

			// Check for shared Internet/ISP IP
			if (!empty($_SERVER['HTTP_CLIENT_IP']) && validate_ip($_SERVER['HTTP_CLIENT_IP'])) {
				return $_SERVER['HTTP_CLIENT_IP'];
			}

			// Check for IP addresses passing through proxies
			if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {

				// Check if multiple IP addresses exist in var
				if (strpos($_SERVER['HTTP_X_FORWARDED_FOR'], ',') !== false) {
					$iplist = explode(',', $_SERVER['HTTP_X_FORWARDED_FOR']);
					foreach ($iplist as $ip) {
						if (validate_ip($ip))
							return $ip;
					}
				}
				else {
					if (validate_ip($_SERVER['HTTP_X_FORWARDED_FOR']))
						return $_SERVER['HTTP_X_FORWARDED_FOR'];
				}
			}
			if (!empty($_SERVER['HTTP_X_FORWARDED']) && validate_ip($_SERVER['HTTP_X_FORWARDED']))
				return $_SERVER['HTTP_X_FORWARDED'];
			if (!empty($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']) && validate_ip($_SERVER['HTTP_X_CLUSTER_CLIENT_IP']))
				return $_SERVER['HTTP_X_CLUSTER_CLIENT_IP'];
			if (!empty($_SERVER['HTTP_FORWARDED_FOR']) && validate_ip($_SERVER['HTTP_FORWARDED_FOR']))
				return $_SERVER['HTTP_FORWARDED_FOR'];
			if (!empty($_SERVER['HTTP_FORWARDED']) && validate_ip($_SERVER['HTTP_FORWARDED']))
				return $_SERVER['HTTP_FORWARDED'];

			// Return unreliable IP address since all else failed
			return $_SERVER['REMOTE_ADDR'];
		}

		/**
		 * Ensures an IP address is both a valid IP address and does not fall within
		 * a private network range.
		 */
		private function validate_ip($ip) {

			if (strtolower($ip) === 'unknown')
				return false;

			// Generate IPv4 network address
			$ip = ip2long($ip);

			// If the IP address is set and not equivalent to 255.255.255.255
			if ($ip !== false && $ip !== -1) {
				// Make sure to get unsigned long representation of IP address
				// due to discrepancies between 32 and 64 bit OSes and
				// signed numbers (ints default to signed in PHP)
				$ip = sprintf('%u', $ip);

				// Do private network range checking
				if ($ip >= 0 && $ip <= 50331647)
					return false;
				if ($ip >= 167772160 && $ip <= 184549375)
					return false;
				if ($ip >= 2130706432 && $ip <= 2147483647)
					return false;
				if ($ip >= 2851995648 && $ip <= 2852061183)
					return false;
				if ($ip >= 2886729728 && $ip <= 2887778303)
					return false;
				if ($ip >= 3221225984 && $ip <= 3221226239)
					return false;
				if ($ip >= 3232235520 && $ip <= 3232301055)
					return false;
				if ($ip >= 4294967040)
					return false;
			}
			return true;
		}

		private function ip_info($ip = NULL, $purpose = "location", $deep_detect = TRUE) 
		{
			$output = NULL;
			if (filter_var($ip, FILTER_VALIDATE_IP) === FALSE) {
				$ip = $_SERVER["REMOTE_ADDR"];
				if ($deep_detect) {
					if (isset($_SERVER['HTTP_X_FORWARDED_FOR']) && filter_var($_SERVER['HTTP_X_FORWARDED_FOR'], FILTER_VALIDATE_IP))
						$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
					if (isset($_SERVER['HTTP_CLIENT_IP']) && filter_var($_SERVER['HTTP_CLIENT_IP'], FILTER_VALIDATE_IP))
						$ip = $_SERVER['HTTP_CLIENT_IP'];
				}
			}
			$purpose    = str_replace(array("name", "\n", "\t", " ", "-", "_"), NULL, strtolower(trim($purpose)));
			$support    = array("country", "countrycode", "state", "region", "city", "location", "address");
			$continents = array(
				"AF" => "Africa",
				"AN" => "Antarctica",
				"AS" => "Asia",
				"EU" => "Europe",
				"OC" => "Australia (Oceania)",
				"NA" => "North America",
				"SA" => "South America"
			);
			if (filter_var($ip, FILTER_VALIDATE_IP) && in_array($purpose, $support)) {
				$ipdat = json_decode(file_get_contents("http://www.geoplugin.net/json.gp?ip=" . $ip));
				if (isset($ipdat) && is_object($ipdat) && isset($ipdat->geoplugin_countryCode) && strlen(trim($ipdat->geoplugin_countryCode)) == 2) {
					switch ($purpose) {
						case "location":
							$output = array(
								"city"           => isset($ipdat->geoplugin_city) ? $ipdat->geoplugin_city : '',
								"state"          => isset($ipdat->geoplugin_regionName) ? $ipdat->geoplugin_regionName : '',
								"country"        => isset($ipdat->geoplugin_countryName) ? $ipdat->geoplugin_countryName : '',
								"country_code"   => isset($ipdat->geoplugin_countryCode) ? $ipdat->geoplugin_countryCode : '',
								"continent"      => isset($ipdat->geoplugin_continentCode) ? $continents[strtoupper($ipdat->geoplugin_continentCode)] : '',
								"continent_code" => isset($ipdat->geoplugin_continentCode) ? $ipdat->geoplugin_continentCode : ''
							);
							break;
						case "address":
							$address = array($ipdat->geoplugin_countryName);
							if (isset($ipdat->geoplugin_regionName) && strlen($ipdat->geoplugin_regionName) >= 1)
								$address[] = $ipdat->geoplugin_regionName;
							if (isset($ipdat->geoplugin_city) && strlen($ipdat->geoplugin_city) >= 1)
								$address[] = $ipdat->geoplugin_city;
							$output = implode(", ", array_reverse($address));
							break;
						case "city":
							$output = isset($ipdat->geoplugin_city) ? $ipdat->geoplugin_city: '';
							break;
						case "state":
							$output = isset($ipdat->geoplugin_regionName) ? $ipdat->geoplugin_regionName : '';
							break;
						case "region":
							$output = isset($ipdat->geoplugin_regionName) ? $ipdat->geoplugin_regionName : '';
							break;
						case "country":
							$output = isset($ipdat->geoplugin_countryName) ? $ipdat->geoplugin_countryName : '';
							break;
						case "countrycode":
							$output = isset($ipdat->geoplugin_countryCode) ? $ipdat->geoplugin_countryCode : '';
							break;
					}
				}
			}
			return $output;
		}
	}
}